/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package fr.eni.technoCeption.vue;

import java.io.IOException;
import java.sql.Array;
import java.sql.SQLException;
import java.text.ParseException;
import java.util.Arrays;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.BorderFactory;
import javax.swing.ImageIcon;
import javax.swing.JOptionPane;
import javax.swing.JPanel;

import fr.eni.technoCeption.controleur.C_AS_AutoSearch;
import fr.eni.technoCeption.db.Db_mysql;
import fr.eni.technoCeption.hash.BCrypt;
import fr.eni.technoCeption.model.M_User;

/**
 *
 * @author gatardf
 */
public class V_Main extends javax.swing.JFrame {

    /**
     * Creates new form V_Main
     */
    //Déclaration des attributs
    private C_AS_AutoSearch leControl;
    private M_User unUtilisateur;
    private Db_mysql bdAutoSearch;
    private String login;

    /**
     * Constructeur de la classe
     * @param leControl : controlleur
     * @param bdAutoSearch  : base de données
     */
    public V_Main(C_AS_AutoSearch leControl,Db_mysql bdAutoSearch) {
        //Initialisation des attributs privées importants
        this.bdAutoSearch = bdAutoSearch;
        this.leControl = leControl;
        initComponents();
    }
    
    /**
     * afficher
     * permet l'affichage de la vue principale
     */
    public void afficher(){
        pn_Connexion.setBorder(BorderFactory.createTitledBorder("Connexion :"));
        ed_login.setText("");
        ed_password.setText("");
        setVisible(true);
    }
    
    /**
     * afficher
     * permet l'affichage de la vue principale
     * @param Retour : chaine de caractère
     */
    public void afficher(String Retour){
        ed_login.setText("");
        ed_password.setText("");
        setVisible(true);
    }
    
    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jMenuBar1 = new javax.swing.JMenuBar();
        jMenu1 = new javax.swing.JMenu();
        jMenu2 = new javax.swing.JMenu();
        pn_Connexion = new javax.swing.JPanel();
        bt_connect = new javax.swing.JButton();
        ed_password = new javax.swing.JPasswordField();
        ed_login = new javax.swing.JTextField();
        lb_password = new javax.swing.JLabel();
        lb_login = new javax.swing.JLabel();

        jMenu1.setText("File");
        jMenuBar1.add(jMenu1);

        jMenu2.setText("Edit");
        jMenuBar1.add(jMenu2);

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("Auto search");
        setMaximumSize(new java.awt.Dimension(300, 250));
        setMinimumSize(new java.awt.Dimension(300, 250));
        setResizable(false);

        pn_Connexion.setToolTipText("");
        pn_Connexion.setAlignmentX(75.0F);
        pn_Connexion.setMaximumSize(new java.awt.Dimension(150, 150));
        pn_Connexion.setMinimumSize(new java.awt.Dimension(150, 150));
        pn_Connexion.setName(""); // NOI18N
        pn_Connexion.setPreferredSize(new java.awt.Dimension(150, 150));

        bt_connect.setText("Connexion");
        bt_connect.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bt_connectActionPerformed(evt);
            }
        });

        ed_password.setToolTipText("");
        ed_password.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                ed_passwordActionPerformed(evt);
            }
        });

        ed_login.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                ed_loginActionPerformed(evt);
            }
        });

        lb_password.setText("Mot de passe");

        lb_login.setText("Login");

        javax.swing.GroupLayout pn_ConnexionLayout = new javax.swing.GroupLayout(pn_Connexion);
        pn_Connexion.setLayout(pn_ConnexionLayout);
        pn_ConnexionLayout.setHorizontalGroup(
            pn_ConnexionLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(pn_ConnexionLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(pn_ConnexionLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(lb_password, javax.swing.GroupLayout.PREFERRED_SIZE, 193, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(lb_login)
                    .addComponent(ed_login, javax.swing.GroupLayout.PREFERRED_SIZE, 110, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(ed_password, javax.swing.GroupLayout.PREFERRED_SIZE, 110, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(bt_connect))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        pn_ConnexionLayout.setVerticalGroup(
            pn_ConnexionLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, pn_ConnexionLayout.createSequentialGroup()
                .addComponent(lb_login)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addComponent(ed_login, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(lb_password)
                .addGap(1, 1, 1)
                .addComponent(ed_password, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(bt_connect)
                .addContainerGap())
        );

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGap(74, 74, 74)
                .addComponent(pn_Connexion, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(76, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGap(21, 21, 21)
                .addComponent(pn_Connexion, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(79, Short.MAX_VALUE))
        );

        pn_Connexion.getAccessibleContext().setAccessibleName("");

        pack();
        setLocationRelativeTo(null);
    }// </editor-fold>//GEN-END:initComponents

    private void ed_loginActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_ed_loginActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_ed_loginActionPerformed

    private void ed_passwordActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_ed_passwordActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_ed_passwordActionPerformed

    private void bt_connectActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_bt_connectActionPerformed
        try {
            //final ImageIcon icon = new ImageIcon("/home/gatardf/Images/teteDeMort.png");
            
            //Cherche l'utilisateur cherchant à se connecter
            unUtilisateur = new M_User(bdAutoSearch, ed_login.getText());
            
            //Déclaration et initialisation de variables
            String mdp = ed_password.getText();
            String passwordUtilisateur = unUtilisateur.getPassword();
            
            //Si le password est différent de rien ( donc le compte existe )
            if(!(passwordUtilisateur.equals("rien"))){
                
                //Initialisation du login et des droits
                login = unUtilisateur.getLogin();
                int droit = unUtilisateur.getDroit();
                
                //Vérifie si le mot de passe scripter est bien identique
                if(BCrypt.checkpw(mdp,passwordUtilisateur)){
                    try {
                        //Affiche la vue V_Consultation en passant en paramètre le login
                        leControl.aff_V_Consultation(login);
                        
                        //masque la vue
                        setVisible(false);
                        
                    //permet de gérer les erreurs
                    } catch (IOException | ParseException | SQLException ex) {
                        Logger.getLogger(V_Main.class.getName()).log(Level.SEVERE, null, ex);
                    }
                //sinon
                }else{
                   //affiche le message d'erreur "Login ou mot de passe incorect !"
                   JOptionPane.showMessageDialog(this, "Login ou mot de passe incorect !", "Attention", JOptionPane.WARNING_MESSAGE);
                }
        
            //sinon
            }else{
                //affiche le message d'erreur "Login ou mot de passe incorect !"
                JOptionPane.showMessageDialog(this, "Login ou mot de passe incorect !", "Attention", JOptionPane.WARNING_MESSAGE);
            }
        
        //permet de gérer les erreurs
        } catch (SQLException ex) {
            Logger.getLogger(V_Main.class.getName()).log(Level.SEVERE, null, ex);
        }
    }//GEN-LAST:event_bt_connectActionPerformed

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(V_Main.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(V_Main.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(V_Main.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(V_Main.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>

        /* Create and display the form */
        java.awt.EventQueue.invokeLater(() -> {
            new V_Main(null,null).setVisible(true);
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton bt_connect;
    private javax.swing.JTextField ed_login;
    private javax.swing.JPasswordField ed_password;
    private javax.swing.JMenu jMenu1;
    private javax.swing.JMenu jMenu2;
    private javax.swing.JMenuBar jMenuBar1;
    private javax.swing.JLabel lb_login;
    private javax.swing.JLabel lb_password;
    private javax.swing.JPanel pn_Connexion;
    // End of variables declaration//GEN-END:variables
}
